#include <srts/stratego.h>
#include <stdlib.h>
#include <limits.h>
#include <stdio.h>

#if HAVE_UNISTD_H
# include <unistd.h>
#endif

/**
 * Tries to return the current directory
 *
 * @todo check for defined PATH_MAX
 */
ATerm SSL_current_working_dir(void)
{
#if HAVE_GETCWD
  char result[PATH_MAX];
  ATerm term_result;
  
  if(getcwd(result, PATH_MAX) == NULL) {
    perror("getcwd failed");
    _fail((ATerm) ATempty);
  }

  term_result = ATmakeString(result);
  return term_result;
#else
  fprintf(stderr, "error: cannot determine the current working dir on this system.\n");
  return NULL;
#endif
}

ATerm SSL_file_exists(ATerm path_term)
{
#if HAVE_ACCESS
  int result = -1;

  if(!ATisString(path_term))
    return NULL;

  const char* pathname  = AT_getString(path_term);
  result = access(pathname, F_OK);
  if(result != 0) {
    _fail(path_term);
  }

  return path_term;
#else
  fprintf(stderr, "error: cannot check for existence of file on this system.\n");
  return NULL;
#endif
}
